Index: code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/ChatInputHandler.cc	(revision 7236)
@@ -46,6 +46,6 @@
 
   /* add commands to console */
-  _SetConsoleCommand( "startchat", &ChatInputHandler::activate_static );
-  _SetConsoleCommand( "startchat_small", &ChatInputHandler::activate_small_static );
+  SetConsoleCommand( "startchat", &ChatInputHandler::activate_static );
+  SetConsoleCommand( "startchat_small", &ChatInputHandler::activate_small_static );
 
   /* constructor */
Index: code/branches/consolecommands3/src/orxonox/Test.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/Test.cc	(revision 7236)
@@ -38,10 +38,10 @@
     CreateFactory ( Test );
 
-    _SetConsoleCommand("Test", "printV1", &Test::printV1).addShortcut();
-    _SetConsoleCommand("Test", "printV2", &Test::printV2).addShortcut();
-    _SetConsoleCommand("Test", "printV3", &Test::printV3).addShortcut();
-    _SetConsoleCommand("Test", "printV4", &Test::printV4).addShortcut();
-    _SetConsoleCommand("Test", "call",    &Test::call).addShortcut();
-    _SetConsoleCommand("Test", "call2",   &Test::call2).addShortcut();
+    SetConsoleCommand("Test", "printV1", &Test::printV1).addShortcut();
+    SetConsoleCommand("Test", "printV2", &Test::printV2).addShortcut();
+    SetConsoleCommand("Test", "printV3", &Test::printV3).addShortcut();
+    SetConsoleCommand("Test", "printV4", &Test::printV4).addShortcut();
+    SetConsoleCommand("Test", "call",    &Test::call).addShortcut();
+    SetConsoleCommand("Test", "call2",   &Test::call2).addShortcut();
 
 
Index: code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/controllers/ArtificialController.cc	(revision 7236)
@@ -47,9 +47,9 @@
 namespace orxonox
 {
-    _SetConsoleCommand("ArtificialController", "formationflight",  &ArtificialController::formationflight);
-    _SetConsoleCommand("ArtificialController", "masteraction",     &ArtificialController::masteraction);
-    _SetConsoleCommand("ArtificialController", "followme",         &ArtificialController::followme);
-    _SetConsoleCommand("ArtificialController", "passivebehaviour", &ArtificialController::passivebehaviour);
-    _SetConsoleCommand("ArtificialController", "formationsize",    &ArtificialController::formationsize);
+    SetConsoleCommand("ArtificialController", "formationflight",  &ArtificialController::formationflight);
+    SetConsoleCommand("ArtificialController", "masteraction",     &ArtificialController::masteraction);
+    SetConsoleCommand("ArtificialController", "followme",         &ArtificialController::followme);
+    SetConsoleCommand("ArtificialController", "passivebehaviour", &ArtificialController::passivebehaviour);
+    SetConsoleCommand("ArtificialController", "formationsize",    &ArtificialController::formationsize);
 
     static const unsigned int STANDARD_MAX_FORMATION_SIZE = 7;
Index: code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/controllers/HumanController.cc	(revision 7236)
@@ -40,24 +40,24 @@
 namespace orxonox
 {
-    _SetConsoleCommand("HumanController", "moveFrontBack",          &HumanController::moveFrontBack ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "moveRightLeft",          &HumanController::moveRightLeft ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "moveUpDown",             &HumanController::moveUpDown    ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "rotateYaw",              &HumanController::rotateYaw     ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "rotatePitch",            &HumanController::rotatePitch   ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "rotateRoll",             &HumanController::rotateRoll    ).addShortcut().setAsInputCommand();
-    _SetConsoleCommand("HumanController", "fire",                   &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
-    _SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
-    _SetConsoleCommand("HumanController", "boost",                  &HumanController::boost         ).addShortcut().keybindMode(KeybindMode::OnHold);
-    _SetConsoleCommand("HumanController", "greet",                  &HumanController::greet         ).addShortcut();
-    _SetConsoleCommand("HumanController", "switchCamera",           &HumanController::switchCamera  ).addShortcut();
-    _SetConsoleCommand("HumanController", "mouseLook",              &HumanController::mouseLook     ).addShortcut();
-    _SetConsoleCommand("HumanController", "suicide",                &HumanController::suicide       ).addShortcut();
-    _SetConsoleCommand("HumanController", "toggleGodMode",          &HumanController::toggleGodMode ).addShortcut();
-    _SetConsoleCommand("HumanController", "addBots",                &HumanController::addBots       ).addShortcut().defaultValues(1);
-    _SetConsoleCommand("HumanController", "killBots",               &HumanController::killBots      ).addShortcut().defaultValues(0);
-    _SetConsoleCommand("HumanController", "dropItems",              &HumanController::dropItems     ).addShortcut();
-    _SetConsoleCommand("HumanController", "useItem",                &HumanController::useItem       ).addShortcut();
-    _SetConsoleCommand("HumanController", "cycleNavigationFocus",   &HumanController::cycleNavigationFocus).addShortcut();
-    _SetConsoleCommand("HumanController", "releaseNavigationFocus", &HumanController::releaseNavigationFocus).addShortcut();
+    SetConsoleCommand("HumanController", "moveFrontBack",          &HumanController::moveFrontBack ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "moveRightLeft",          &HumanController::moveRightLeft ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "moveUpDown",             &HumanController::moveUpDown    ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotateYaw",              &HumanController::rotateYaw     ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotatePitch",            &HumanController::rotatePitch   ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "rotateRoll",             &HumanController::rotateRoll    ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "fire",                   &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
+    SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
+    SetConsoleCommand("HumanController", "boost",                  &HumanController::boost         ).addShortcut().keybindMode(KeybindMode::OnHold);
+    SetConsoleCommand("HumanController", "greet",                  &HumanController::greet         ).addShortcut();
+    SetConsoleCommand("HumanController", "switchCamera",           &HumanController::switchCamera  ).addShortcut();
+    SetConsoleCommand("HumanController", "mouseLook",              &HumanController::mouseLook     ).addShortcut();
+    SetConsoleCommand("HumanController", "suicide",                &HumanController::suicide       ).addShortcut();
+    SetConsoleCommand("HumanController", "toggleGodMode",          &HumanController::toggleGodMode ).addShortcut();
+    SetConsoleCommand("HumanController", "addBots",                &HumanController::addBots       ).addShortcut().defaultValues(1);
+    SetConsoleCommand("HumanController", "killBots",               &HumanController::killBots      ).addShortcut().defaultValues(0);
+    SetConsoleCommand("HumanController", "dropItems",              &HumanController::dropItems     ).addShortcut();
+    SetConsoleCommand("HumanController", "useItem",                &HumanController::useItem       ).addShortcut();
+    SetConsoleCommand("HumanController", "cycleNavigationFocus",   &HumanController::cycleNavigationFocus).addShortcut();
+    SetConsoleCommand("HumanController", "releaseNavigationFocus", &HumanController::releaseNavigationFocus).addShortcut();
 
     CreateUnloadableFactory(HumanController);
Index: code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/controllers/NewHumanController.cc	(revision 7236)
@@ -49,8 +49,8 @@
 namespace orxonox
 {
-    _SetConsoleCommand("NewHumanController", "changeMode", &NewHumanController::changeMode).keybindMode(KeybindMode::OnPress);
-    _SetConsoleCommand("NewHumanController", "accelerate", &NewHumanController::accelerate).keybindMode(KeybindMode::OnPress);
-    _SetConsoleCommand("NewHumanController", "decelerate", &NewHumanController::decelerate).keybindMode(KeybindMode::OnPress);
-    _SetConsoleCommand("NewHumanController", "unfire",     &NewHumanController::unfire    ).keybindMode(KeybindMode::OnRelease).addShortcut();
+    SetConsoleCommand("NewHumanController", "changeMode", &NewHumanController::changeMode).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "accelerate", &NewHumanController::accelerate).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "decelerate", &NewHumanController::decelerate).keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("NewHumanController", "unfire",     &NewHumanController::unfire    ).keybindMode(KeybindMode::OnRelease).addShortcut();
 
     CreateUnloadableFactory(NewHumanController);
Index: code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/gamestates/GSMainMenu.cc	(revision 7236)
@@ -55,10 +55,10 @@
     static const std::string __CC_setMainMenuSoundPath_name = "setMMSoundPath";
 
-    _SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).deactivate();
-    _SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).deactivate();
-    _SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).deactivate();
-    _SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).deactivate();
-    _SetConsoleCommand(__CC_startMainMenu_name,        &GSMainMenu::startMainMenu  ).deactivate();
-    _SetConsoleCommand(__CC_setMainMenuSoundPath_name, &GSMainMenu::setMainMenuSoundPath).hide();
+    SetConsoleCommand(__CC_startStandalone_name,      &GSMainMenu::startStandalone).deactivate();
+    SetConsoleCommand(__CC_startServer_name,          &GSMainMenu::startServer    ).deactivate();
+    SetConsoleCommand(__CC_startClient_name,          &GSMainMenu::startClient    ).deactivate();
+    SetConsoleCommand(__CC_startDedicated_name,       &GSMainMenu::startDedicated ).deactivate();
+    SetConsoleCommand(__CC_startMainMenu_name,        &GSMainMenu::startMainMenu  ).deactivate();
+    SetConsoleCommand(__CC_setMainMenuSoundPath_name, &GSMainMenu::setMainMenuSoundPath).hide();
 
     GSMainMenu::GSMainMenu(const GameStateInfo& info)
@@ -103,10 +103,10 @@
         InputManager::getInstance().enterState("MainMenuHackery");
 
-        _ModifyConsoleCommand(__CC_startStandalone_name).activate();
-        _ModifyConsoleCommand(__CC_startServer_name    ).activate();
-        _ModifyConsoleCommand(__CC_startClient_name    ).activate();
-        _ModifyConsoleCommand(__CC_startDedicated_name ).activate();
-        _ModifyConsoleCommand(__CC_startMainMenu_name  ).activate();
-        _ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(this);
+        ModifyConsoleCommand(__CC_startStandalone_name).activate();
+        ModifyConsoleCommand(__CC_startServer_name    ).activate();
+        ModifyConsoleCommand(__CC_startClient_name    ).activate();
+        ModifyConsoleCommand(__CC_startDedicated_name ).activate();
+        ModifyConsoleCommand(__CC_startMainMenu_name  ).activate();
+        ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(this);
 
         KeyBinderManager::getInstance().setToDefault();
@@ -135,10 +135,10 @@
         GraphicsManager::getInstance().setCamera(0);
 
-        _ModifyConsoleCommand(__CC_startStandalone_name).deactivate();
-        _ModifyConsoleCommand(__CC_startServer_name    ).deactivate();
-        _ModifyConsoleCommand(__CC_startClient_name    ).deactivate();
-        _ModifyConsoleCommand(__CC_startDedicated_name ).deactivate();
-        _ModifyConsoleCommand(__CC_startMainMenu_name  ).deactivate();
-        _ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(0);
+        ModifyConsoleCommand(__CC_startStandalone_name).deactivate();
+        ModifyConsoleCommand(__CC_startServer_name    ).deactivate();
+        ModifyConsoleCommand(__CC_startClient_name    ).deactivate();
+        ModifyConsoleCommand(__CC_startDedicated_name ).deactivate();
+        ModifyConsoleCommand(__CC_startMainMenu_name  ).deactivate();
+        ModifyConsoleCommand(__CC_setMainMenuSoundPath_name).setObject(0);
     }
 
Index: code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/gamestates/GSRoot.cc	(revision 7236)
@@ -45,7 +45,7 @@
     static const std::string __CC_pause_name = "pause";
 
-    _SetConsoleCommand("printObjects", &GSRoot::printObjects).hide();
-    _SetConsoleCommand(__CC_setTimeFactor_name, &GSRoot::setTimeFactor).accessLevel(AccessLevel::Master).defaultValues(1.0);
-    _SetConsoleCommand(__CC_pause_name,         &GSRoot::pause        ).accessLevel(AccessLevel::Master);
+    SetConsoleCommand("printObjects", &GSRoot::printObjects).hide();
+    SetConsoleCommand(__CC_setTimeFactor_name, &GSRoot::setTimeFactor).accessLevel(AccessLevel::Master).defaultValues(1.0);
+    SetConsoleCommand(__CC_pause_name,         &GSRoot::pause        ).accessLevel(AccessLevel::Master);
 
     registerStaticNetworkFunction(&TimeFactorListener::setTimeFactor);
@@ -82,12 +82,12 @@
         TimeFactorListener::setTimeFactor(1.0f);
 
-        _ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(this);
-        _ModifyConsoleCommand(__CC_pause_name).setObject(this);
+        ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(this);
+        ModifyConsoleCommand(__CC_pause_name).setObject(this);
     }
 
     void GSRoot::deactivate()
     {
-        _ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(0);
-        _ModifyConsoleCommand(__CC_pause_name).setObject(0);
+        ModifyConsoleCommand(__CC_setTimeFactor_name).setObject(0);
+        ModifyConsoleCommand(__CC_pause_name).setObject(0);
     }
 
Index: code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/overlays/InGameConsole.cc	(revision 7236)
@@ -58,6 +58,6 @@
     const float CHAR_WIDTH = 7.45f; // fix this please - determine the char-width dynamically
 
-    _SetConsoleCommand("InGameConsole", "openConsole", &InGameConsole::openConsole).addShortcut();
-    _SetConsoleCommand("InGameConsole", "closeConsole", &InGameConsole::closeConsole).addShortcut();
+    SetConsoleCommand("InGameConsole", "openConsole", &InGameConsole::openConsole).addShortcut();
+    SetConsoleCommand("InGameConsole", "closeConsole", &InGameConsole::closeConsole).addShortcut();
 
     ManageScopedSingleton(InGameConsole, ScopeID::Graphics, false);
Index: code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/overlays/OrxonoxOverlay.cc	(revision 7236)
@@ -57,8 +57,8 @@
     std::map<std::string, OrxonoxOverlay*> OrxonoxOverlay::overlays_s;
 
-    _SetConsoleCommand("OrxonoxOverlay", "scaleOverlay",     &OrxonoxOverlay::scaleOverlay);
-    _SetConsoleCommand("OrxonoxOverlay", "scrollOverlay",    &OrxonoxOverlay::scrollOverlay);
-    _SetConsoleCommand("OrxonoxOverlay", "toggleVisibility", &OrxonoxOverlay::toggleVisibility);
-    _SetConsoleCommand("OrxonoxOverlay", "rotateOverlay",    &OrxonoxOverlay::rotateOverlay);
+    SetConsoleCommand("OrxonoxOverlay", "scaleOverlay",     &OrxonoxOverlay::scaleOverlay);
+    SetConsoleCommand("OrxonoxOverlay", "scrollOverlay",    &OrxonoxOverlay::scrollOverlay);
+    SetConsoleCommand("OrxonoxOverlay", "toggleVisibility", &OrxonoxOverlay::toggleVisibility);
+    SetConsoleCommand("OrxonoxOverlay", "rotateOverlay",    &OrxonoxOverlay::rotateOverlay);
 
     OrxonoxOverlay::OrxonoxOverlay(BaseObject* creator)
Index: code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc
===================================================================
--- code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc	(revision 7233)
+++ code/branches/consolecommands3/src/orxonox/overlays/OverlayGroup.cc	(revision 7236)
@@ -43,7 +43,7 @@
     CreateFactory(OverlayGroup);
 
-    _SetConsoleCommand("OverlayGroup", "toggleVisibility", &OverlayGroup::toggleVisibility);
-    _SetConsoleCommand("OverlayGroup", "scaleGroup",       &OverlayGroup::scaleGroup);
-    _SetConsoleCommand("OverlayGroup", "scrollGroup",      &OverlayGroup::scrollGroup);
+    SetConsoleCommand("OverlayGroup", "toggleVisibility", &OverlayGroup::toggleVisibility);
+    SetConsoleCommand("OverlayGroup", "scaleGroup",       &OverlayGroup::scaleGroup);
+    SetConsoleCommand("OverlayGroup", "scrollGroup",      &OverlayGroup::scrollGroup);
 
     OverlayGroup::OverlayGroup(BaseObject* creator)