Index: branches/resources/src/lib/util/loading/resource.cc
===================================================================
--- branches/resources/src/lib/util/loading/resource.cc	(revision 7239)
+++ branches/resources/src/lib/util/loading/resource.cc	(revision 7240)
@@ -2,5 +2,5 @@
    orxonox - the future of 3D-vertical-scrollers
 
-   Copyright (C) 2004 orx
+   Copyright (C) 2006 orx
 
    This program is free software; you can redistribute it and/or modify
@@ -21,4 +21,7 @@
 namespace Loading
 {
+  /**
+   * @brief Initializes a shared Resource
+   */
   Resource::SharedResource::SharedResource()
   {
@@ -30,5 +33,5 @@
 
   /**
-   * standard constructor
+   * @brief standard constructor
   */
   Resource::Resource (const std::string& fileName, ResourcePriority prio)
@@ -40,9 +43,8 @@
 
   /**
-   * standard deconstructor
+   * @brief standard deconstructor
    */
-  //   Resource::~Resource ()
-  //   {
-  //   }
+  Resource::~Resource ()
+  {}
 
 
@@ -50,4 +52,6 @@
                       const MultiType& param0, const MultiType& param1, const MultiType& param2)
   {}
+
+
   bool Resource::cache(std::string& fileName, ResourcePriority prio,
                        const MultiType& param0, const MultiType& param1,  const MultiType& param2)
@@ -55,8 +59,10 @@
 
 
-  // reloads the resource.
-//  bool Resource::reload()
-//  {}
-  // unloads the sharedResource (from this Resource)
+  /**
+   * @brief reloads the resource.
+   */
+  bool Resource::reload()
+  {}
+
   bool Resource::unload()
   {}
@@ -71,9 +77,27 @@
   {}
 
-//   const SharedResource* findResource(std::string& fileName,
-//                                      const MultiType& param0, const MultiType& param1, const MultiType& param2)
-//   {
-//   }
+
+  bool Resource::reloadResourcesByType(ClassID ResourceType)
+  {}
+
+  bool Resource::reloadAllResources()
+  {}
+
+  bool Resource::unloadResourcesByType(ResourcePriority prio)
+  {}
 
 
+  bool Resource::unloadAllResources()
+  {}
+
+  void Resource::debug()
+  {}
+
+
+
+
+  const Resource::SharedResource* Resource::findResource(std::string& fileName,
+      const MultiType& param0, const MultiType& param1, const MultiType& param2)
+  {}
+
 }
Index: branches/resources/src/lib/util/loading/resource.h
===================================================================
--- branches/resources/src/lib/util/loading/resource.h	(revision 7239)
+++ branches/resources/src/lib/util/loading/resource.h	(revision 7240)
@@ -53,4 +53,5 @@
     public:
       SharedResource();
+      bool reload();
       std::string       fileName;
 
@@ -65,5 +66,5 @@
   public:
     Resource(const std::string& fileName = "", ResourcePriority prio = RP_LEVEL);
-    virtual ~Resource() {};
+    virtual ~Resource();
 
     // looks if the resource was already loaded and (if not) loads it.
@@ -73,4 +74,5 @@
                       const MultiType& param1 = MT_NULL,
                       const MultiType& param2 = MT_NULL);
+
     virtual bool cache(std::string& fileName = "",
                        ResourcePriority prio = RP_LEVEL,
@@ -81,13 +83,13 @@
 
     // reloads the resource.
-    virtual bool reload() { };
+    virtual bool reload();
     // unloads the sharedResource (from this Resource)
     virtual bool unload();
 
     // checks if a resource was already loaded.
-    bool isLoaded(std::string& fileName,
-                  const MultiType& param0 = MT_NULL,
-                  const MultiType& param1 = MT_NULL,
-                  const MultiType& param2 = MT_NULL);
+    static bool isLoaded(std::string& fileName,
+                         const MultiType& param0 = MT_NULL,
+                         const MultiType& param1 = MT_NULL,
+                         const MultiType& param2 = MT_NULL);
 
     // raises the priority can only be raised
@@ -95,6 +97,13 @@
 
     /** @returns the referenceCount of the shared resource behind this resource or 0 if no internal Resource is stored */
-  unsigned int referenceCount() const { return (this->resource)? this->resource->referenceCount : 0; };
+    unsigned int referenceCount() const { return (this->resource)? this->resource->referenceCount : 0; };
 
+    static bool reloadResourcesByType(ClassID ResourceType);
+    static bool reloadAllResources();
+
+    static bool unloadResourcesByType(ResourcePriority prio);
+    static bool unloadAllResources();
+
+    static void debug();
   protected:
     const SharedResource* findResource(std::string& fileName,