Index: branches/preferences/src/lib/graphics/graphics_engine.cc
===================================================================
--- branches/preferences/src/lib/graphics/graphics_engine.cc	(revision 7246)
+++ branches/preferences/src/lib/graphics/graphics_engine.cc	(revision 7247)
@@ -30,4 +30,5 @@
 
 #include "parser/ini_parser/ini_parser.h"
+#include "util/preferences.h"
 #include "substring.h"
 #include "text.h"
@@ -154,13 +155,14 @@
  * @returns nothing usefull
  */
-int GraphicsEngine::initFromIniFile(IniParser* iniParser)
+int GraphicsEngine::initFromPreferences()
 {
   // looking if we are in fullscreen-mode
-  const std::string fullscreen = iniParser->getVar(CONFIG_NAME_FULLSCREEN, CONFIG_SECTION_VIDEO, "0");
+  const std::string fullscreen = Preferences::getInstance()->getString(CONFIG_SECTION_VIDEO, CONFIG_NAME_FULLSCREEN, "0");
+
   if (fullscreen[0] == '1' || fullscreen == "true")
     this->fullscreenFlag = SDL_FULLSCREEN;
 
   // looking if we are in fullscreen-mode
-  const std::string textures = iniParser->getVar(CONFIG_NAME_TEXTURES, CONFIG_SECTION_VIDEO_ADVANCED, "0");
+  const std::string textures = Preferences::getInstance()->getString(CONFIG_SECTION_VIDEO_ADVANCED, CONFIG_NAME_TEXTURES, "0");
   if (textures[0] == '1' || textures == "true")
     Texture::setTextureEnableState(true);
@@ -169,5 +171,5 @@
 
   // searching for a usefull resolution
-  SubString resolution(iniParser->getVar(CONFIG_NAME_RESOLUTION, CONFIG_SECTION_VIDEO, "640x480").c_str(), 'x'); ///FIXME
+  SubString resolution(Preferences::getInstance()->getString(CONFIG_SECTION_VIDEO, CONFIG_NAME_RESOLUTION, "640x480").c_str(), 'x'); ///FIXME
   //resolution.debug();
   MultiType x = resolution.getString(0), y = resolution.getString(1);
Index: branches/preferences/src/lib/graphics/graphics_engine.h
===================================================================
--- branches/preferences/src/lib/graphics/graphics_engine.h	(revision 7246)
+++ branches/preferences/src/lib/graphics/graphics_engine.h	(revision 7247)
@@ -39,5 +39,5 @@
 
     int init();
-    int initFromIniFile(IniParser* iniParser);
+    int initFromPreferences();
 
     void setWindowName(const std::string& windowName, const std::string& icon);
Index: branches/preferences/src/lib/sound/sound_engine.cc
===================================================================
--- branches/preferences/src/lib/sound/sound_engine.cc	(revision 7246)
+++ branches/preferences/src/lib/sound/sound_engine.cc	(revision 7247)
@@ -26,5 +26,5 @@
 #include "util/loading/resource_manager.h"
 #include "debug.h"
-#include "parser/ini_parser/ini_parser.h"
+#include "util/preferences.h"
 #include "globals.h"
 
@@ -97,13 +97,13 @@
  * @param iniParser the IniParser of the inifile
  */
-void SoundEngine::loadSettings(IniParser* iniParser)
-{
-  MultiType channels = iniParser->getVar(CONFIG_NAME_AUDIO_CHANNELS, CONFIG_SECTION_AUDIO, "32");
+void SoundEngine::loadSettings()
+{
+  MultiType channels = Preferences::getInstance()->getString(CONFIG_SECTION_AUDIO, CONFIG_NAME_AUDIO_CHANNELS, "32");
   this->maxSourceCount = channels.getInt();
 
-  MultiType effectsVolume = iniParser->getVar(CONFIG_NAME_EFFECTS_VOLUME, CONFIG_SECTION_AUDIO, "80");
+  MultiType effectsVolume = Preferences::getInstance()->getString(CONFIG_SECTION_AUDIO, CONFIG_NAME_EFFECTS_VOLUME, "80");
   this->effectsVolume = effectsVolume.getFloat()/100.0;
 
-  MultiType musicVolume = iniParser->getVar(CONFIG_NAME_MUSIC_VOLUME, CONFIG_SECTION_AUDIO, "75");
+  MultiType musicVolume = Preferences::getInstance()->getString(CONFIG_SECTION_AUDIO, CONFIG_NAME_MUSIC_VOLUME, "75");
   this->musicVolume = musicVolume.getFloat()/100.0;
 }
Index: branches/preferences/src/lib/sound/sound_engine.h
===================================================================
--- branches/preferences/src/lib/sound/sound_engine.h	(revision 7246)
+++ branches/preferences/src/lib/sound/sound_engine.h	(revision 7247)
@@ -31,5 +31,5 @@
     inline static SoundEngine* getInstance() { if (!SoundEngine::singletonRef) SoundEngine::singletonRef = new SoundEngine();  return SoundEngine::singletonRef; };
 
-    void loadSettings(IniParser* iniParser);
+    void loadSettings();
 
     SoundSource* createSource(const std::string& fileName, PNode* sourceNode = NULL);